
/*
 * This file is part of the netcc project
 *
 * (C) 2011 Andreas Steinmetz, ast@domdv.de
 * The contents of this file is licensed under the GPL version 2.
 */

#ifndef CLNTLOG_H
#define CLNTLOG_H

/* various logging macros for the client utilities */

#define ERR(a,...) clienterr("%s %s %d %s%s%s: " a "\n",app,__FILE__,__LINE__, \
	in?"(":"",in?in:"",in?")":"",##__VA_ARGS__)
#define REDO(a,...) {ERR(a ", trying local compile",##__VA_ARGS__);goto redo;}
#define FAIL(a,...) {ERR(a,##__VA_ARGS__);exit(255);}
#define BAD(a,...) {if(UNLIKELY(verbose))ERR(a,##__VA_ARGS__);return -1;}
#define BADJUMP(a,b,...) {if(UNLIKELY(verbose))ERR(b,##__VA_ARGS__);goto a;}
#define BADMSG(a,...) {if(UNLIKELY(verbose))ERR(a,##__VA_ARGS__);}
#define DEBUG(a,...) {if(UNLIKELY(verbose>1))ERR(a,##__VA_ARGS__);}

/* globals that must be provided by each client utility */

extern int verbose;
extern char *in;
extern char *app;

/* prototypes */

extern void clienterr(char *fmt,...);

#endif
