
/*
 * This file is part of the netcc project
 *
 * (C) 2011 Andreas Steinmetz, ast@domdv.de
 * The contents of this file is licensed under the GPL version 2.
 */

#ifndef IPC_H
#define IPC_H

/* counter and condition definitions */

#define COUNTER_0	0
#define COUNTER_1	1
#define MAXCOUNTERS	2

#define COND_0		0
#define COND_1		1
#define MAXCOND		2

/* kill unneeded functions for safe uid systems, else prototype them */

#ifdef SAFEUID
#define ipc_needex()
#define ipc_exdone()
#else
extern void ipc_needex(void);
extern void ipc_exdone(void);
#endif

/* prototypes */

extern int ipc_join(int key,char *np,int super);
extern int ipc_leave(int super);

extern int ipc_waitevent(void);
extern int ipc_postevent(void);

extern void ipc_adj(int idx,int val);
extern void ipc_superadj(int idx,int val);
extern int ipc_get(int idx);
extern int ipc_sum(int idx);

extern void ipc_lock(int idx);
extern void ipc_unlock(int idx);
extern void ipc_signal(int idx);
extern void ipc_bcast(int idx);
extern void ipc_sigwait(int idx);

#endif
