
/*
 * This file is part of the netcc project
 *
 * (C) 2011 Andreas Steinmetz, ast@domdv.de
 * The contents of this file is licensed under the GPL version 2.
 */

#ifndef LOCK_H
#define LOCK_H

/* use macros for locking if locking debug is disabled */

#ifndef LOCKDEBUG

extern pthread_rwlock_t rw;

#define initlock() pthread_rwlock_init(&rw,NULL)
#define exitlock() pthread_rwlock_destroy(&rw)
#define shlock()   pthread_rwlock_rdlock(&rw)
#define exlock()   pthread_rwlock_wrlock(&rw)
#define unlock()   pthread_rwlock_unlock(&rw)

/* use debug macros and prototypes if locking debug is enabled */

#else

#define shlock() _shlock(__FILE__,__LINE__)
#define exlock() _exlock(__FILE__,__LINE__)
#define unlock() _unlock(__FILE__,__LINE__)

extern int initlock(void);
extern int exitlock(void);
extern void _shlock(char *file,int line);
extern void _exlock(char *file,int line);
extern void _unlock(char *file,int line);

#endif

#endif
