
/*
 * This file is part of the netcc project
 *
 * (C) 2011 Andreas Steinmetz, ast@domdv.de
 * The contents of this file is licensed under the GPL version 2.
 */

#ifndef REALPATH_H
#define REALPATH_H

#if defined(__OpenBSD__) || defined(__NetBSD__)

/*
 * fix_broken_realpath
 *
 * description:	This routine fixes realpath implementations that
 *		choke on NULL for resolvedname as they don't dynamically
 *		allocate memory (what a mess).
 */

static inline char *fix_broken_realpath(char *pathname,char *resolvedname)
{
	char *p;
	char bfr[MAXPATHLEN+1];

	if(UNLIKELY(!(p=realpath(pathname,resolvedname?resolvedname:bfr))))
		return NULL;
	if(LIKELY(!resolvedname))return strdup(bfr);
	else return p;
}

#define realpath fix_broken_realpath

#endif

#endif
