
/*
 * This file is part of the netcc project
 *
 * (C) 2011 Andreas Steinmetz, ast@domdv.de
 * The contents of this file is licensed under the GPL version 2.
 */

#ifndef SAFEAPI_H
#define SAFEAPI_H

/* first assert a clean environment */

#ifdef SAFEAPI
#undef SAFEAPI
#endif

#ifdef SAFEUID
#undef SAFEUID
#endif

/* define SAFEAPI for systmes where safe api usage may be possible */

#if defined(O_CLOEXEC) && defined(SOCK_CLOEXEC) && defined(IN_CLOEXEC)

#define SAFEAPI

#define safeapi() safeapi

extern int safeapi;

#endif

/* this prototype resolves in a no-op for non safe systems */

extern int enablesafeapi(void);

/* define SAFEUID for systems that have a per thread uid/gid functionality
   for filesystem access */

#if defined(__linux__)
#define SAFEUID
#endif

#endif
