
/*
 * This file is part of the netcc project
 *
 * (C) 2011 Andreas Steinmetz, ast@domdv.de
 * The contents of this file is licensed under the GPL version 2.
 */

#ifndef SIGS_H
#define SIGS_H

/* processing mode definitions */

#define THREAD  0
#define PROCESS 1
#define ALLSIGS 2

/* definitions that choose between somewhat modern and antique systems */

#if defined(__linux__) || defined(__FreeBSD__) || defined(__OpenBSD__) || defined(__NetBSD__)
#define block(a,b)
#define unblock(a,b)
#define sigstore(a)
#else
#define sigstore(a) sigset_t a
#endif

/* common prototypes */

extern int dftblock(int how);
extern int sethandler(void *routine);

#if !defined(__linux__) && !defined(__FreeBSD__) && !defined(__OpenBSD__) && !defined(__NetBSD__)

/* prototypes for antique systems that do need the old signal handlers */

extern int block(int how,sigset_t *m);
extern int unblock(int how,sigset_t *m);
#endif

#endif
