
/*
 * This file is part of the netcc project
 *
 * (C) 2011 Andreas Steinmetz, ast@domdv.de
 * The contents of this file is licensed under the GPL version 2.
 */

#ifndef STAMP_H
#define STAMP_H

/* timestamp definitions for systems that accept NULL as input to times() */

#if defined(__linux__)

#define timestamp() times(NULL)

/* ugly workaround for systems that expect a times() parameter */

#elif defined(__FreeBSD__) || defined(__OpenBSD__) || defined(__NetBSD__)

static inline clock_t timestamp(void)
{
	struct tms unused;

	return times(&unused);
}

#else
#error timestamp() needs to be defined
#endif

#endif
