
/*
 * This file is part of the netcc project
 *
 * (C) 2011 Andreas Steinmetz, ast@domdv.de
 * The contents of this file is licensed under the GPL version 2.
 */

#ifndef TCP_H
#define TCP_H

/* prototypes */

extern int tcpsocket(char *dev,int port,int backlog);
extern int tcpconnect(int addr,int port,int ttl);

/* the whoes of TCP_CORK and friends, neatly macro packaged */

#if defined(__linux__)

#define cork(a) \
	do{int b=1;setsockopt(a,SOL_TCP,TCP_CORK,&b,sizeof(b));}while(0)
#define uncork(a) \
	do{int b=0;setsockopt(a,SOL_TCP,TCP_CORK,&b,sizeof(b));}while(0)

#elif defined(__FreeBSD__)

#define cork(a) \
	do{int b=1;setsockopt(a,IPPROTO_TCP,TCP_NOPUSH,&b,sizeof(b));}while(0)
#define uncork(a) \
	do{int b=0;setsockopt(a,IPPROTO_TCP,TCP_NOPUSH,&b,sizeof(b));}while(0)

#elif defined(__OpenBSD__) || defined(__NetBSD__)

#define cork(a)
#define uncork(a)

#else

#warning no TCP_CORK or equivalent socket option available
#define cork(a)
#define uncork(a)

#endif

#endif
