
/*
 * This file is part of the netcc project
 *
 * (C) 2011 Andreas Steinmetz, ast@domdv.de
 * The contents of this file is licensed under the GPL version 2.
 */

#ifndef UDP_H
#define UDP_H

/* udp socket management data */

typedef struct
{
	int udp;
	int port;
	int idx;
	int srcport;
	int srcaddr;
	int addr;
	int mask;
	int net;
	int mode;
	int bcast;
	int mcast;
} UDP;

/* prototypes */

extern int udpsocket(char *dev,int port,UDP *data,int mode,int ttl,char *mcast);
extern int udpclose(UDP *data);
extern int udprecv(UDP *data,void *bfr,int len);
extern int udpsend(UDP *data,int dst,void *bfr,int len);
extern int udpnewdev(char *dev,UDP *data);

#endif
