
/*
 * This file is part of the netcc project
 *
 * (C) 2011 Andreas Steinmetz, ast@domdv.de
 * The contents of this file is licensed under the GPL version 2.
 */

#ifndef UDP6_H
#define UDP6_H

/* udp socket management data */

typedef struct
{
	int udp;
	int port;
	int idx;
	int mode;
	int srcport;
	int srcidx;
	struct in6_addr addr;
	struct in6_addr mcast;
} UDP6;

/* prototypes */

extern int udp6socket(char *dev,int port,UDP6 *data,int mode,int ttl,
	char *mcast);
extern int udp6close(UDP6 *data);
extern int udp6recv(UDP6 *data,void *bfr,int len);
extern int udp6send(UDP6 *data,int dst,void *bfr,int len);
extern int udp6newdev(char *dev,UDP6 *data);

#endif
