
/*
 * This file is part of the netcc project
 *
 * (C) 2011 Andreas Steinmetz, ast@domdv.de
 * The contents of this file is licensed under the GPL version 2.
 */

#ifndef UGID_H
#define UGID_H

/* partial and hopefully sufficiently correct implementation of
   setresuid/setresgid surrogates for lacking systems  - the
   correctness is with regards to the needs of this application */

#if defined(__NetBSD__)

static inline int setresuid(uid_t ruid,uid_t euid,uid_t suid)
{
	if(suid)return setuid(suid);
	else return seteuid(euid);
}

static inline int setresgid(gid_t rgid,gid_t egid,gid_t sgid)
{
	if(sgid)return setgid(sgid);
	else return setegid(egid);
}

#endif

#endif
