
/*
 * This file is part of the netcc project
 *
 * (C) 2011 Andreas Steinmetz, ast@domdv.de
 * The contents of this file is licensed under the GPL version 2.
 */

#ifndef UPDATE_H
#define UPDATE_H

/* action definitions for updatemgr() */

#define UPDATE_START	0
#define UPDATE_STOP	1
#define UPDATE_NETWORK	2
#define UPDATE_ARCH	3
#define UPDATE_OS	4
#define UPDATE_MEMFREE	5
#define UPDATE_USEV6	6
#define UPDATE_MCAST	7
#define UPDATE_SITE	8
#define UPDATE_TTL	9
#define UPDATE_AUTH	10
#define UPDATE_WINDOW	11
#define UPDATE_NOMIX	12
#define UPDATE_UNIQUE	13
#define UPDATE_MCADDR	14
#define UPDATE_USERMT	15

/* action definitions for update_mode() */

#define UPDATE_DISABLE	0
#define UPDATE_ENABLE	1
#define JOB_PENDING	2
#define JOB_NEW		3
#define JOB_DONE	4
#define QUEUED_JOBS	5
#define FAST_CPU_MHZ	6
#define CLIENT_ONLY	7
#define LOCAL_ONLY	8
#define BCAST_SPEED	9
#define SYSTEM_LOAD	10
#define SYSTEM_BROKEN	11
#define CFG_FLAGS	12
#define GCC_VERSION	13

/* prototypes */

extern int update_mode(int how,int val,int *stamp,...);
extern int updatemgr(int mode,char *dev,int port);
extern int select_service(int pending,int localonly,struct in6_addr *addr6,
	int *flags,int *unique);
extern char *getswitch1(void);
extern char *getswitch2(void);
extern int isclient(void);
extern void safe_cancel(pthread_t h);
extern char *htmlstats(void);

#endif
